> {-# LANGUAGE FlexibleContexts #-}
>
> import Control.Monad.Trans.Maybe
> import Control.Monad.State
>

За это задание не будет баллов и сдавать его не надо.
Но, тем не менее, надо со всем этим хорошо разобраться, а то мало ли что.


◊1 Запустите программу (`stack runhaskell Game.lhs`).

◊2 Убедитесь, что вы совершенно точно понимаете, как работает весь этот код,
   и, если потребуется, сможете объяснить товарищу, который не понимает (или мне).

>
> type Position = (Int, Int)
>
> data GameState = GameState { gsPos :: Position }
>   deriving Show
>
> initState :: GameState
> initState = GameState (0,0)
>
> target :: Position
> target = (2, 2)
>
> fieldSize :: Int
> fieldSize = 2
>


По сравнению с тем, что было на паре, я написал отдельную функцию,
которая убивает игрока, и вызываю её из `move`.

Я указал у всех функций наиболее общий тип, и это прикольно.

Функция `killPlayer` просто прерывает вычисление. Я не знаю никакого
другого общего способа это сделать, так что применил функцию `mzero :: m a`
из класса `MonadPlus`. Соответственно, в типе и написано, что это функция
имеет тип любой монады, реализующей `MonadPlus`. В частности, `MaybeT`,
разумеется, реализует `MonadPlus`, также, как и стек монад, в котором
на одном из уровней есть монада, реализующая `MonadPlus`.

>
> killPlayer :: MonadPlus m => m ()
> killPlayer = mzero
>


Функция `move` читает состояние, в котором содержится `GameState`, и
изменяет его. Соответсвенно, использовать её можно в любой монаде, реализующей
`MonadState GameState` (например, `StateT GameState`).
Поскольку эта функция также вызывает `killPlayer`, нужен ещё и `MonadPlus`.

>
> data Direction = North | South | West | East
>
> move :: (MonadState GameState m, MonadPlus m) => Direction -> m ()
> move d = do
>            gs <- get
>            put $ gs { gsPos = newPos (gsPos gs) }
>            (x, y) <- gets gsPos
>            when (abs x > fieldSize || abs y > fieldSize) killPlayer
>   where
>     newPos (x, y) = case d of
>                       North -> (x, y + 1)
>                       South -> (x, y - 1)
>                       West  -> (x - 1, y)
>                       East  -> (x + 1, y)
>

`gameScript` вызывает `move` и использует состояние, так что монада
должна реализовывать `MonadState GameState` и `MonadPlus`.

>
> gameScript :: (MonadState GameState m, MonadPlus m) => m Bool
> gameScript = do
>                move North
>                move West
>                move North
>                move West
>                pos <- gets gsPos
>                pure $ pos == target
>


Теперь самое интересное.
Если не смотреть на то, что идет дальше, то функция `gameScript` имеет весьма общий
тип — можно представлять это себе так, будто она исопльзет некий «интерфейс»: дающий
доступ к состоянию и позволяющий прервать вычисление, вернув что-то вроде «ошибки».

Как именно будет обеспечиваться доступ к состоянию и прерывание вычисления, зависит
от того, как мы будем её вызывать. Именно в месте вызова мы определяем конкретные
«реализации интерфейса», причем обычно, собственно, тип указывать не надо, поскольку он
выводится просто из того, как мы «разворачиваем» монадическое значение.

>
> main :: IO ()
> main = print $ runState (runMaybeT gameScript) initState
>

`runMaybeT :: MaybeT m a -> m (Maybe a)` и первым параметром мы туда передаем gameScript —
из этого следует, что `gameScript :: MaybeT m a` . Тем самым, мы уже обеспечили
необходимое для вызова `gameScript` условие про `MonadPlus`, но `m` ещё до конца не определено.

К результату вызова `runMaybeT` применяется `runState :: State s a -> s -> (a, s)`,
из чего следует, что `m` это `State s a` (ну ещё из того, что мы используем `initState`,
выводится, что `s` это `GameState`, но это сейчас не так важно). Таким образом, чтобы наш вызов
состоялся, нужно чтобы `gameState :: MaybeT (State GameState) Bool`, что верно, поскольку
это как раз частный случай реального типа `gameState`.



◊3 Сейчас при падении игрока в пропасть возвращается состояние, хранящее его последнюю позицию.
   Сделайте так, чтобы при смерти состояние пропадало совсем. В нашем случае
   оба варианта имеют право на существование, но иногда так бывает, что в случае ошибки
   состояние просто не определено, так что возвращать нечего.
   Прежде, чем приступать, убедитесь, что понимаете, что для этого надо изменить ровно
   одну строчку.

◊4 Сейчас наличие или отсутствие ответа показывается с помощью `Maybe`: есть ответ, тогда `Just`,
   нет ответа — `Nothing`. Сделайте так, чтобы для этого использовался список: есть ответ, тогда
   список из одного элемента, нет ответа — пустой список.
   Убедитесь, что понимаете, что для этого надо изменить одну строчку (и добавить импорт, ок).

◊5 Сделайте так, чтобы игра считала количество ходов пользователя. Убедитесь, что понимаете,
   что для числ ходов не надо хранить в состоянии. Убедитесь, что понимаете, как вам может
   пригодиться моноид `Sum`.
   Вывод программы должен выглядеть как-нибудь так, или что-то вроде того:

     ((Just False,Sum {getSum = 4}),GameState {gsPos = (-2,2)})
                                ^ чило ходов

◊6 Поиграйте с разными вариантами `main`, позапускайте программу, посмотрите, что происходит.
